# Prologue.
import os
execfile(os.path.join(os.path.dirname(__file__), '../../Dll/main/prologue.py'))

import re
import os, gc
import sys
import weakref

import unittest
from log.StdLogger import logger

from testing.mock import MockObject, MockOpenFunc
import testing.mock
import testing.ut

from cal3d import pycal3d

class Test(unittest.TestCase):
    def setUp(self):
        self.cal3d_ = pycal3d.Cal3d()
        
    def tearDown(self):
        pass

    def testSkel(self):
        self.hereAndBackAgain(origData=skeleton1, calCoreType="CoreSkeleton")

    # TODO: fix this test (probably needs new data)
    def broken_testSkelAnimation(self):
        self.hereAndBackAgain(origData=animation1, calCoreType="CoreAnimation")

    # TODO: fix this test (probably needs new data)
    def broken_testSkelAnimation2(self):
        self.hereAndBackAgain(origData=animation2, calCoreType="CoreAnimation")

    def testMaterial(self):
        self.hereAndBackAgain(origData=material1, calCoreType="CoreMaterial")

    def testAnimatedMorph(self):
        self.hereAndBackAgain(origData=animmorph1, calCoreType="CoreAnimatedMorph")
        

    def assertEqual(self, a, b):
        f = open("dataA", "w")
        f.write(str(a))
        f.close()
        f = open("dataB", "w")
        f.write(str(b))
        f.close()
        unittest.TestCase.assertEqual(self, a,b)
       
    def hereAndBackAgain(self, origData, calCoreType):
        data = self.cal3d_.convertToBinary(calCoreType=calCoreType, data=origData)
        assert len(data) < len(origData)


        data3 = re.sub("\s+", "", origData)
        data4 = self.cal3d_.convertToXml(calCoreType=calCoreType, data=data)
        data4 = re.sub("POSDIFF=\".+\"", "", data3)
        data4 = re.sub("\s+", "", data3)
        self.assertEqual(len(data3), len(data4))
        self.assertEqual(data3, data4)
        
        data2 = self.cal3d_.convertToBinary(calCoreType=calCoreType, data=data)
        self.assertEqual(repr(data), repr(data2))
        self.assertEqual(len(data), len(data2))

    def testMesh(self):
        self.hereAndBackAgain(origData=mesh1, calCoreType="CoreMesh")
        
    def testXmlExtension(self):
        path = "/foo/bar/baz/test.xsf"
        self.assertEqual(self.cal3d_.cal3dTypeForPath(path), "CoreSkeleton")
        path = "test.csf"
        self.assertEqual(self.cal3d_.cal3dTypeForPath(path), "CoreSkeleton")
        


skeleton1 = """<HEADER VERSION="910" MAGIC="XSF" />
<SKELETON SCENEAMBIENTCOLOR="1 1 1" NUMBONES="2">
    <BONE NAME="FemaleAnimeRoot" NUMCHILDS="1" ID="0">
        <TRANSLATION>0 1.31134e-006 -30</TRANSLATION>
        <ROTATION>0 0 0 1</ROTATION>
        <LOCALTRANSLATION>0 -1.31134e-006 30</LOCALTRANSLATION>
        <LOCALROTATION>0 0 0 1</LOCALROTATION>
        <PARENTID>-1</PARENTID>
        <CHILDID>1</CHILDID>
    </BONE>
    <BONE NAME="PelvisNode" NUMCHILDS="3" ID="1">
        <TRANSLATION>0 -10.3201 519.784</TRANSLATION>
        <ROTATION>0 0 0 1</ROTATION>
        <LOCALTRANSLATION>0 10.3201 -489.784</LOCALTRANSLATION>
        <LOCALROTATION>0 0 0 1</LOCALROTATION>
        <PARENTID>0</PARENTID>
    </BONE>
</SKELETON>"""

mesh1 = """<HEADER VERSION="910" MAGIC="XMF" />
<MESH NUMSUBMESH="1">
    <SUBMESH NUMVERTICES="11" NUMFACES="6" NUMLODSTEPS="0" NUMSPRINGS="0" NUMMORPHS="9" NUMTEXCOORDS="1" MATERIAL="2">
        <VERTEX NUMINFLUENCES="1" ID="0">
            <POS>30.7542 -112.13 825.308</POS>
            <NORM>-0.857233 0.397024 0.327908</NORM>
            <COLOR>1.35632e-019 1.35632e-019 1.35632e-019</COLOR>
            <TEXCOORD>0.571776 0.980153</TEXCOORD>
            <INFLUENCE ID="22">1</INFLUENCE>
        </VERTEX>
        <VERTEX NUMINFLUENCES="1" ID="1">
            <POS>21.5894 -115.955 805.98</POS>
            <NORM>-0.807413 0.586997 -0.0593164</NORM>
            <COLOR>1.35632e-019 1.35632e-019 1.35632e-019</COLOR>
            <TEXCOORD>0.552218 0.978547</TEXCOORD>
            <INFLUENCE ID="22">1</INFLUENCE>
        </VERTEX>
        <VERTEX NUMINFLUENCES="1" ID="2">
            <POS>16.7126 -120.828 804.738</POS>
            <NORM>-0.460269 0.441253 -0.770356</NORM>
            <COLOR>0 3.82554e-043 3.81153e-043</COLOR>
            <TEXCOORD>0.527233 0.977693</TEXCOORD>
            <INFLUENCE ID="22">1</INFLUENCE>
        </VERTEX>
        <VERTEX NUMINFLUENCES="1" ID="3">
            <POS>30.7542 -112.13 825.308</POS>
            <NORM>-0.27356 0.943696 -0.186018</NORM>
            <COLOR>0 0 1.00893e-043</COLOR>
            <TEXCOORD>0.571776 0.980153</TEXCOORD>
            <INFLUENCE ID="22">1</INFLUENCE>
        </VERTEX>
        <VERTEX NUMINFLUENCES="1" ID="4">
            <POS>9.46755 -122.028 806.4</POS>
            <NORM>-0.186905 0.971857 -0.143389</NORM>
            <COLOR>1.4013e-043 0 0</COLOR>
            <TEXCOORD>0.521052 0.976423</TEXCOORD>
            <INFLUENCE ID="22">1</INFLUENCE>
        </VERTEX>
        <VERTEX NUMINFLUENCES="1" ID="5">
            <POS>0.340274 -121.767 824.44</POS>
            <NORM>3.52695e-009 0.991284 -0.131742</NORM>
            <COLOR>2.30786e-011 1.03696e-043 0</COLOR>
            <TEXCOORD>0.522246 0.974824</TEXCOORD>
            <INFLUENCE ID="22">1</INFLUENCE>
        </VERTEX>
        <VERTEX NUMINFLUENCES="1" ID="6">
            <POS>0.340274 -122.581 804.669</POS>
            <NORM>-3.02535e-008 0.999153 -0.041138</NORM>
            <COLOR>1.66755e-043 0 0</COLOR>
            <TEXCOORD>0.518241 0.974824</TEXCOORD>
            <INFLUENCE ID="22">1</INFLUENCE>
        </VERTEX>
        <VERTEX NUMINFLUENCES="1" ID="7">
            <POS>16.7126 -120.828 804.738</POS>
            <NORM>-0.214234 0.943525 -0.252715</NORM>
            <COLOR>1.96935e-020 7.84727e-043 2.38221e-044</COLOR>
            <TEXCOORD>0.527233 0.977693</TEXCOORD>
            <INFLUENCE ID="22">1</INFLUENCE>
        </VERTEX>
        <VERTEX NUMINFLUENCES="1" ID="8">
            <POS>0.340268 -109.433 792.513</POS>
            <NORM>3.95365e-007 0.697319 0.716761</NORM>
            <COLOR>-332.537 1.56945e-043 2.38221e-044</COLOR>
            <TEXCOORD>0.585726 0.974824</TEXCOORD>
            <INFLUENCE ID="22">1</INFLUENCE>
        </VERTEX>
        <VERTEX NUMINFLUENCES="1" ID="9">
            <POS>0.340274 -120.596 803.374</POS>
            <NORM>8.04736e-008 0.445458 0.895303</NORM>
            <COLOR>2.09443e-038 0 0</COLOR>
            <TEXCOORD>0.528441 0.974824</TEXCOORD>
            <INFLUENCE ID="22">1</INFLUENCE>
        </VERTEX>
        <VERTEX NUMINFLUENCES="1" ID="10">
            <POS>20.2896 -106.929 794.81</POS>
            <NORM>-0.129956 0.645329 0.75277</NORM>
            <COLOR>-1.4013e-043 0 0</COLOR>
            <TEXCOORD>0.59854 0.97832</TEXCOORD>
            <INFLUENCE ID="22">1</INFLUENCE>
        </VERTEX>
        
        
        
        
        <MORPH NAME="left.Eye.Down.Clamped" NUMBLENDVERTS="0" MORPHID="0" />
        <MORPH NAME="left.Eye.Left.Clamped" NUMBLENDVERTS="0" MORPHID="1" />
        <MORPH NAME="left.Eye.Right.Clamped" NUMBLENDVERTS="0" MORPHID="2" />
        <MORPH NAME="left.Eye.Up.Clamped" NUMBLENDVERTS="0" MORPHID="3" />
        <MORPH NAME="right.Eye.Down.Clamped" NUMBLENDVERTS="0" MORPHID="4" />
        <MORPH NAME="right.Eye.Left.Clamped" NUMBLENDVERTS="0" MORPHID="5" />
        <MORPH NAME="right.Eye.Right.Clamped" NUMBLENDVERTS="0" MORPHID="6" />
        <MORPH NAME="right.Eye.Up.Clamped" NUMBLENDVERTS="0" MORPHID="7" />
        <MORPH NAME="eyes.Blink.Clamped" NUMBLENDVERTS="10" MORPHID="8">
            <BLENDVERTEX VERTEXID="0">
                <POSITION>7.69704 -121.396 862.701</POSITION>
                <NORMAL>0.475756 -0.861712 -0.176376</NORMAL>
                <TEXCOORD>0.508674 0.275276</TEXCOORD>
            </BLENDVERTEX>
            <BLENDVERTEX VERTEXID="1">
                <POSITION>71.2067 -85.9199 860.71</POSITION>
                <NORMAL>0.865095 -0.4979 -0.06088</NORMAL>
                <TEXCOORD>0.636769 0.276661</TEXCOORD>
            </BLENDVERTEX>
            <BLENDVERTEX VERTEXID="2">
                <POSITION>65.5313 -89.114 852.661</POSITION>
                <NORMAL>0.714048 -0.680395 -0.164917</NORMAL>
                <TEXCOORD>0.626629 0.291508</TEXCOORD>
            </BLENDVERTEX>
            <BLENDVERTEX VERTEXID="3">
                <POSITION>66.4918 -87.6711 848.23</POSITION>
                <NORMAL>0.721416 -0.689776 -0.0613941</NORMAL>
                <TEXCOORD>0.629534 0.300306</TEXCOORD>
            </BLENDVERTEX>
            <BLENDVERTEX VERTEXID="4">
                <POSITION>72.3876 -80.8385 848.623</POSITION>
                <NORMAL>0.903905 -0.422648 -0.065763</NORMAL>
                <TEXCOORD>0.647298 0.300101</TEXCOORD>
            </BLENDVERTEX>
            <BLENDVERTEX VERTEXID="5">
                <POSITION>56.955 -104.788 853.335</POSITION>
                <NORMAL>0.558053 -0.504662 -0.658706</NORMAL>
                <TEXCOORD>0.601702 0.300145</TEXCOORD>
            </BLENDVERTEX>
            <BLENDVERTEX VERTEXID="6">
                <POSITION>50.0733 -108.024 852.259</POSITION>
                <NORMAL>0.297636 -0.624358 -0.722212</NORMAL>
                <TEXCOORD>0.587854 0.304354</TEXCOORD>
            </BLENDVERTEX>
            <BLENDVERTEX VERTEXID="7">
                <POSITION>49.1971 -103.946 848.372</POSITION>
                <NORMAL>0.386808 -0.762641 -0.518419</NORMAL>
                <TEXCOORD>0.587099 0.307948</TEXCOORD>
            </BLENDVERTEX>
            <BLENDVERTEX VERTEXID="8">
                <POSITION>57.8752 -99.3678 850.163</POSITION>
                <NORMAL>0.700746 -0.568581 -0.430895</NORMAL>
                <TEXCOORD>0.604766 0.30405</TEXCOORD>
            </BLENDVERTEX>
            <BLENDVERTEX VERTEXID="9">
                <POSITION>14.8428 -112.115 862.01</POSITION>
                <NORMAL>0.589296 -0.79844 -0.123384</NORMAL>
                <TEXCOORD>0.526391 0.269252</TEXCOORD>
            </BLENDVERTEX>
        </MORPH>
        <FACE VERTEXID="0 1 2" />
        <FACE VERTEXID="3 4 5" />
        <FACE VERTEXID="4 6 5" />
        <FACE VERTEXID="7 4 3" />
        <FACE VERTEXID="8 9 5" />
        <FACE VERTEXID="9 3 5" />
    </SUBMESH>
</MESH>"""

animation1 = """<HEADER VERSION="910" MAGIC="XAF" />
<ANIMATION NUMTRACKS="5" DURATION="4">
    <TRACK NUMKEYFRAMES="32" BONEID="56">
        <KEYFRAME TIME="0">
            <TRANSLATION>95.4475 -0.29209 -0.0204049</TRANSLATION>
            <ROTATION>0.569964 -0.437345 0.517176 -0.465187</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3">
            <TRANSLATION>95.4475 -0.29209 -0.0204049</TRANSLATION>
            <ROTATION>0.564503 -0.461901 0.501256 -0.465538</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.03333">
            <TRANSLATION>95.4475 -0.29209 -0.0204049</TRANSLATION>
            <ROTATION>0.564902 -0.460634 0.501926 -0.465589</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.06667">
            <TRANSLATION>95.4475 -0.29209 -0.0204049</TRANSLATION>
            <ROTATION>0.565299 -0.459325 0.502633 -0.465637</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.1">
            <TRANSLATION>95.4475 -0.29209 -0.0204049</TRANSLATION>
            <ROTATION>0.56569 -0.45799 0.503371 -0.465679</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.13333">
            <TRANSLATION>95.4475 -0.29209 -0.0204049</TRANSLATION>
            <ROTATION>0.566074 -0.45663 0.504142 -0.465715</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.16667">
            <TRANSLATION>95.4475 -0.29209 -0.0204049</TRANSLATION>
            <ROTATION>0.566443 -0.455268 0.504932 -0.465744</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.2">
            <TRANSLATION>95.4475 -0.29209 -0.0204049</TRANSLATION>
            <ROTATION>0.566798 -0.453906 0.50574 -0.465765</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.23333">
            <TRANSLATION>95.4475 -0.29209 -0.0204049</TRANSLATION>
            <ROTATION>0.567136 -0.45255 0.506564 -0.465777</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.26667">
            <TRANSLATION>95.4475 -0.29209 -0.0204049</TRANSLATION>
            <ROTATION>0.567455 -0.451218 0.507392 -0.46578</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.3">
            <TRANSLATION>95.4475 -0.29209 -0.0204049</TRANSLATION>
            <ROTATION>0.567756 -0.449899 0.508229 -0.465775</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.33333">
            <TRANSLATION>95.4475 -0.29209 -0.0204049</TRANSLATION>
            <ROTATION>0.568038 -0.448611 0.509065 -0.465761</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.36667">
            <TRANSLATION>95.4475 -0.29209 -0.0204049</TRANSLATION>
            <ROTATION>0.5683 -0.447359 0.509895 -0.465739</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.4">
            <TRANSLATION>95.4475 -0.29209 -0.0204049</TRANSLATION>
            <ROTATION>0.568542 -0.446143 0.510717 -0.465708</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.43333">
            <TRANSLATION>95.4475 -0.29209 -0.0204049</TRANSLATION>
            <ROTATION>0.568762 -0.444987 0.511515 -0.46567</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.46667">
            <TRANSLATION>95.4475 -0.29209 -0.0204049</TRANSLATION>
            <ROTATION>0.568962 -0.443888 0.512286 -0.465627</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.5">
            <TRANSLATION>95.4475 -0.29209 -0.0204049</TRANSLATION>
            <ROTATION>0.569142 -0.442853 0.513026 -0.465578</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.53333">
            <TRANSLATION>95.4475 -0.29209 -0.0204049</TRANSLATION>
            <ROTATION>0.569302 -0.441893 0.513723 -0.465526</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.56667">
            <TRANSLATION>95.4475 -0.29209 -0.0204049</TRANSLATION>
            <ROTATION>0.569443 -0.441004 0.514378 -0.465472</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.6">
            <TRANSLATION>95.4475 -0.29209 -0.0204049</TRANSLATION>
            <ROTATION>0.569567 -0.440197 0.514982 -0.465418</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.63333">
            <TRANSLATION>95.4475 -0.29209 -0.0204049</TRANSLATION>
            <ROTATION>0.569674 -0.439474 0.515529 -0.465366</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.66667">
            <TRANSLATION>95.4475 -0.29209 -0.0204049</TRANSLATION>
            <ROTATION>0.569762 -0.438849 0.516006 -0.465317</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.7">
            <TRANSLATION>95.4475 -0.29209 -0.0204049</TRANSLATION>
            <ROTATION>0.569835 -0.438325 0.516411 -0.465274</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.73333">
            <TRANSLATION>95.4475 -0.29209 -0.0204049</TRANSLATION>
            <ROTATION>0.569891 -0.437906 0.516737 -0.465237</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.76667">
            <TRANSLATION>95.4475 -0.29209 -0.0204049</TRANSLATION>
            <ROTATION>0.569931 -0.4376 0.516976 -0.46521</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.8">
            <TRANSLATION>95.4475 -0.29209 -0.0204049</TRANSLATION>
            <ROTATION>0.569956 -0.437411 0.517125 -0.465193</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.83333">
            <TRANSLATION>95.4475 -0.29209 -0.0204049</TRANSLATION>
            <ROTATION>0.569964 -0.437345 0.517176 -0.465187</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.86667">
            <TRANSLATION>95.4475 -0.29209 -0.0204049</TRANSLATION>
            <ROTATION>0.569964 -0.437345 0.517176 -0.465187</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.9">
            <TRANSLATION>95.4475 -0.29209 -0.0204049</TRANSLATION>
            <ROTATION>0.569964 -0.437345 0.517176 -0.465187</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.93333">
            <TRANSLATION>95.4475 -0.29209 -0.0204049</TRANSLATION>
            <ROTATION>0.569964 -0.437345 0.517176 -0.465187</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.96667">
            <TRANSLATION>95.4475 -0.29209 -0.0204049</TRANSLATION>
            <ROTATION>0.569964 -0.437345 0.517176 -0.465187</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="4">
            <TRANSLATION>95.4475 -0.29209 -0.0204049</TRANSLATION>
            <ROTATION>0.569964 -0.437345 0.517176 -0.465187</ROTATION>
        </KEYFRAME>
    </TRACK>
    <TRACK NUMKEYFRAMES="32" BONEID="57">
        <KEYFRAME TIME="0">
            <TRANSLATION>-94.9605 -9.48851e-005 2.88643e-006</TRANSLATION>
            <ROTATION>0.322539 0.588375 -0.579296 0.462817</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3">
            <TRANSLATION>-94.9605 -4.55434e-005 3.9704e-006</TRANSLATION>
            <ROTATION>-0.0611443 -0.627387 0.771113 0.0896201</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.03333">
            <TRANSLATION>-94.9605 -2.97193e-005 1.22749e-006</TRANSLATION>
            <ROTATION>-0.0589109 -0.627065 0.771595 0.0892196</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.06667">
            <TRANSLATION>-94.9605 -7.32982e-005 -1.84994e-007</TRANSLATION>
            <ROTATION>-0.0568738 -0.627006 0.771925 0.0880897</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.1">
            <TRANSLATION>-94.9605 -6.6281e-005 4.31833e-006</TRANSLATION>
            <ROTATION>-0.0564557 -0.627169 0.772342 0.0834265</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.13333">
            <TRANSLATION>-94.9605 -8.00995e-005 3.72933e-006</TRANSLATION>
            <ROTATION>-0.0589326 -0.627472 0.772993 0.0727196</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.16667">
            <TRANSLATION>-94.9605 -9.89769e-005 -4.52926e-006</TRANSLATION>
            <ROTATION>-0.0640326 -0.627875 0.773604 0.0566621</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.2">
            <TRANSLATION>-94.9605 -9.90162e-005 -1.67586e-006</TRANSLATION>
            <ROTATION>-0.0715313 -0.628315 0.773837 0.0357753</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.23333">
            <TRANSLATION>-94.9605 -6.51164e-005 -1.31578e-006</TRANSLATION>
            <ROTATION>-0.0812016 -0.62871 0.773316 0.0106469</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.26667">
            <TRANSLATION>-94.9605 -4.34946e-005 5.4158e-006</TRANSLATION>
            <ROTATION>-0.0927371 -0.628963 0.771676 -0.0179216</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.3">
            <TRANSLATION>-94.9605 -4.5916e-005 5.50144e-006</TRANSLATION>
            <ROTATION>-0.106049 -0.628982 0.76855 -0.0496512</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.33333">
            <TRANSLATION>-94.9605 -8.82345e-005 3.12064e-006</TRANSLATION>
            <ROTATION>-0.120829 -0.628668 0.763656 -0.0837072</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.36667">
            <TRANSLATION>-94.9605 -5.3489e-005 1.87621e-006</TRANSLATION>
            <ROTATION>-0.136822 -0.627934 0.756783 -0.119403</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.4">
            <TRANSLATION>-94.9605 -0.000115604 1.81096e-006</TRANSLATION>
            <ROTATION>-0.153868 -0.626703 0.747761 -0.156274</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.43333">
            <TRANSLATION>-94.9605 -9.36538e-005 -2.70465e-006</TRANSLATION>
            <ROTATION>-0.171474 -0.624942 0.736703 -0.193166</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.46667">
            <TRANSLATION>-94.9605 -6.3082e-005 3.34916e-006</TRANSLATION>
            <ROTATION>-0.189449 -0.622628 0.723679 -0.229635</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.5">
            <TRANSLATION>-94.9605 -6.76616e-005 4.43534e-006</TRANSLATION>
            <ROTATION>-0.207488 -0.619773 0.708929 -0.265046</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.53333">
            <TRANSLATION>-94.9605 -3.58452e-005 5.96365e-006</TRANSLATION>
            <ROTATION>-0.225168 -0.616452 0.692907 -0.298608</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.56667">
            <TRANSLATION>-94.9605 -6.49661e-005 3.50357e-006</TRANSLATION>
            <ROTATION>-0.242397 -0.612707 0.675861 -0.330221</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.6">
            <TRANSLATION>-94.9605 -3.82724e-005 6.78129e-006</TRANSLATION>
            <ROTATION>-0.258742 -0.608682 0.658426 -0.359213</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.63333">
            <TRANSLATION>-94.9605 -4.56537e-005 -6.61357e-008</TRANSLATION>
            <ROTATION>-0.273978 -0.604508 0.6411 -0.385353</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.66667">
            <TRANSLATION>-94.9605 -8.23829e-005 -7.94134e-007</TRANSLATION>
            <ROTATION>-0.287602 -0.600424 0.624752 -0.407996</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.7">
            <TRANSLATION>-94.9605 -8.16911e-005 -3.21283e-007</TRANSLATION>
            <ROTATION>-0.299407 -0.596609 0.609952 -0.42705</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.73333">
            <TRANSLATION>-94.9605 -7.6184e-005 -4.3729e-006</TRANSLATION>
            <ROTATION>-0.309095 -0.593285 0.597374 -0.442287</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.76667">
            <TRANSLATION>-94.9605 -9.15017e-005 3.17584e-006</TRANSLATION>
            <ROTATION>0.316335 0.590684 -0.587727 0.453434</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.8">
            <TRANSLATION>-94.9605 -4.14264e-005 4.11736e-006</TRANSLATION>
            <ROTATION>0.320929 0.588981 -0.581497 0.460399</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.83333">
            <TRANSLATION>-94.9605 -9.46325e-005 9.96234e-007</TRANSLATION>
            <ROTATION>0.322539 0.588375 -0.579296 0.462817</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.86667">
            <TRANSLATION>-94.9605 -9.48851e-005 2.88643e-006</TRANSLATION>
            <ROTATION>0.322539 0.588375 -0.579296 0.462817</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.9">
            <TRANSLATION>-94.9605 -9.48851e-005 2.88643e-006</TRANSLATION>
            <ROTATION>0.322539 0.588375 -0.579296 0.462817</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.93333">
            <TRANSLATION>-94.9605 -9.48851e-005 2.88643e-006</TRANSLATION>
            <ROTATION>0.322539 0.588375 -0.579296 0.462817</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.96667">
            <TRANSLATION>-94.9605 -9.48851e-005 2.88643e-006</TRANSLATION>
            <ROTATION>0.322539 0.588375 -0.579296 0.462817</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="4">
            <TRANSLATION>-94.9605 -9.48851e-005 2.88643e-006</TRANSLATION>
            <ROTATION>0.322539 0.588375 -0.579296 0.462817</ROTATION>
        </KEYFRAME>
    </TRACK>
    <TRACK NUMKEYFRAMES="32" BONEID="58">
        <KEYFRAME TIME="0">
            <TRANSLATION>43.9686 -8.88883e-007 -3.60704e-005</TRANSLATION>
            <ROTATION>0.0188448 0.0488381 -0.00770525 0.998599</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3">
            <TRANSLATION>43.9686 -8.05016e-006 -2.83851e-005</TRANSLATION>
            <ROTATION>-0.297082 0.043915 -0.0227158 0.953571</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.03333">
            <TRANSLATION>43.9686 -1.42594e-005 -8.21696e-005</TRANSLATION>
            <ROTATION>-0.288796 0.0441105 -0.0223339 0.956113</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.06667">
            <TRANSLATION>43.9686 -6.11722e-006 -3.55719e-005</TRANSLATION>
            <ROTATION>-0.279745 0.0443196 -0.0219159 0.9588</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.1">
            <TRANSLATION>43.9686 -1.61471e-006 -3.77367e-005</TRANSLATION>
            <ROTATION>-0.26952 0.0445505 -0.0214428 0.961725</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.13333">
            <TRANSLATION>43.9686 -4.48747e-007 -8.98891e-006</TRANSLATION>
            <ROTATION>-0.257705 0.0448101 -0.0208948 0.964958</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.16667">
            <TRANSLATION>43.9686 -1.05368e-006 -2.51094e-006</TRANSLATION>
            <ROTATION>-0.244613 0.045089 -0.020286 0.96836</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.2">
            <TRANSLATION>43.9686 5.88961e-006 -4.22187e-005</TRANSLATION>
            <ROTATION>-0.230345 0.0453824 -0.0196207 0.971852</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.23333">
            <TRANSLATION>43.9686 -7.08612e-006 -3.04502e-005</TRANSLATION>
            <ROTATION>-0.215076 0.0456846 -0.0189066 0.975345</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.26667">
            <TRANSLATION>43.9686 -1.40071e-005 -5.90604e-005</TRANSLATION>
            <ROTATION>-0.199084 0.0459879 -0.0181563 0.978734</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.3">
            <TRANSLATION>43.9686 2.61801e-006 -2.64273e-005</TRANSLATION>
            <ROTATION>-0.182348 0.0462911 -0.0173687 0.98199</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.33333">
            <TRANSLATION>43.9686 -3.02582e-006 -5.65601e-005</TRANSLATION>
            <ROTATION>-0.16515 0.0465877 -0.0165566 0.985029</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.36667">
            <TRANSLATION>43.9686 7.24104e-006 -4.53921e-006</TRANSLATION>
            <ROTATION>-0.147674 0.0468737 -0.0157288 0.987799</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.4">
            <TRANSLATION>43.9686 1.5131e-005 1.16243e-005</TRANSLATION>
            <ROTATION>-0.130002 0.0471472 -0.0148888 0.99028</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.43333">
            <TRANSLATION>43.9686 1.01785e-005 7.51126e-007</TRANSLATION>
            <ROTATION>-0.112544 0.0474021 -0.0140562 0.992416</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.46667">
            <TRANSLATION>43.9686 1.50875e-005 -2.42128e-005</TRANSLATION>
            <ROTATION>-0.0953821 0.0476379 -0.0132352 0.994212</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.5">
            <TRANSLATION>43.9686 -4.13826e-006 -5.32784e-005</TRANSLATION>
            <ROTATION>-0.0787105 0.047853 -0.0124352 0.995671</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.53333">
            <TRANSLATION>43.9686 -2.53503e-006 -3.4705e-005</TRANSLATION>
            <ROTATION>-0.0628196 0.0480452 -0.0116703 0.996799</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.56667">
            <TRANSLATION>43.9686 2.36464e-006 -3.76053e-005</TRANSLATION>
            <ROTATION>-0.0477021 0.0482166 -0.0109407 0.997637</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.6">
            <TRANSLATION>43.9685 -2.01711e-006 -3.96523e-005</TRANSLATION>
            <ROTATION>-0.0336526 0.0483658 -0.0102608 0.99821</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.63333">
            <TRANSLATION>43.9686 -1.19226e-006 -4.43825e-005</TRANSLATION>
            <ROTATION>-0.0207872 0.048494 -0.00963673 0.998561</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.66667">
            <TRANSLATION>43.9686 -9.47661e-007 -3.86478e-005</TRANSLATION>
            <ROTATION>-0.00945659 0.0486003 -0.00908592 0.998732</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.7">
            <TRANSLATION>43.9685 2.0907e-009 -3.8424e-005</TRANSLATION>
            <ROTATION>0.000233916 0.0486862 -0.00861396 0.998777</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.73333">
            <TRANSLATION>43.9686 -1.14782e-006 -3.36582e-005</TRANSLATION>
            <ROTATION>0.00809632 0.0487524 -0.00823042 0.998744</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.76667">
            <TRANSLATION>43.9685 -2.29865e-007 -3.90786e-005</TRANSLATION>
            <ROTATION>0.0139137 0.0487995 -0.00794631 0.99868</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.8">
            <TRANSLATION>43.9685 1.30403e-007 -1.3182e-005</TRANSLATION>
            <ROTATION>0.0175731 0.0488283 -0.00776744 0.998622</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.83333">
            <TRANSLATION>43.9686 3.28427e-007 -4.18209e-005</TRANSLATION>
            <ROTATION>0.0188448 0.0488382 -0.00770526 0.998599</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.86667">
            <TRANSLATION>43.9686 -8.88883e-007 -3.60704e-005</TRANSLATION>
            <ROTATION>0.0188448 0.0488381 -0.00770525 0.998599</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.9">
            <TRANSLATION>43.9686 -8.88883e-007 -3.60704e-005</TRANSLATION>
            <ROTATION>0.0188448 0.0488381 -0.00770525 0.998599</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.93333">
            <TRANSLATION>43.9686 -8.88883e-007 -3.60704e-005</TRANSLATION>
            <ROTATION>0.0188448 0.0488381 -0.00770525 0.998599</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.96667">
            <TRANSLATION>43.9686 -8.88883e-007 -3.60704e-005</TRANSLATION>
            <ROTATION>0.0188448 0.0488381 -0.00770525 0.998599</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="4">
            <TRANSLATION>43.9686 -8.88883e-007 -3.60704e-005</TRANSLATION>
            <ROTATION>0.0188448 0.0488381 -0.00770525 0.998599</ROTATION>
        </KEYFRAME>
    </TRACK>
    <TRACK NUMKEYFRAMES="32" BONEID="59">
        <KEYFRAME TIME="0">
            <TRANSLATION>91.2128 4.06705e-005 2.5501e-005</TRANSLATION>
            <ROTATION>-0.00596945 0.0368511 -0.237566 0.970654</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3">
            <TRANSLATION>91.2129 1.21172e-005 3.55895e-005</TRANSLATION>
            <ROTATION>0.00984135 0.0357772 -0.619065 0.784463</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.03333">
            <TRANSLATION>91.2129 1.80665e-005 4.19845e-005</TRANSLATION>
            <ROTATION>0.0100391 0.0357458 -0.62321 0.781173</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.06667">
            <TRANSLATION>91.2129 6.52349e-005 5.14624e-005</TRANSLATION>
            <ROTATION>0.0101684 0.0357268 -0.625906 0.779013</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.1">
            <TRANSLATION>91.2129 4.41837e-005 3.74079e-005</TRANSLATION>
            <ROTATION>0.0102148 0.0357204 -0.626871 0.778237</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.13333">
            <TRANSLATION>91.2129 3.69847e-005 5.62322e-005</TRANSLATION>
            <ROTATION>0.0101209 0.0356645 -0.624819 0.779889</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.16667">
            <TRANSLATION>91.2129 3.45264e-006 2.82499e-005</TRANSLATION>
            <ROTATION>0.00984967 0.0355076 -0.618897 0.784607</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.2">
            <TRANSLATION>91.2129 2.84497e-005 4.64944e-005</TRANSLATION>
            <ROTATION>0.00941573 0.0352718 -0.609427 0.792002</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.23333">
            <TRANSLATION>91.2129 5.05568e-005 7.08403e-005</TRANSLATION>
            <ROTATION>0.00883264 0.0349823 -0.596705 0.801649</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.26667">
            <TRANSLATION>91.2129 4.21172e-005 1.93249e-005</TRANSLATION>
            <ROTATION>0.00811944 0.0346693 -0.581132 0.81303</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.3">
            <TRANSLATION>91.2129 4.4828e-005 7.69265e-005</TRANSLATION>
            <ROTATION>0.00728216 0.0343575 -0.562803 0.825845</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.33333">
            <TRANSLATION>91.2129 5.36816e-005 1.98742e-005</TRANSLATION>
            <ROTATION>0.00634202 0.0340756 -0.542119 0.839587</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.36667">
            <TRANSLATION>91.2128 4.86168e-005 8.52224e-005</TRANSLATION>
            <ROTATION>0.00531756 0.0338476 -0.519412 0.853837</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.4">
            <TRANSLATION>91.2128 4.28391e-005 4.34281e-005</TRANSLATION>
            <ROTATION>0.00422266 0.0336924 -0.494888 0.868293</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.43333">
            <TRANSLATION>91.2128 4.03538e-005 4.56777e-005</TRANSLATION>
            <ROTATION>0.00309354 0.0336268 -0.469243 0.882423</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.46667">
            <TRANSLATION>91.2129 4.39868e-005 2.11678e-005</TRANSLATION>
            <ROTATION>0.00194702 0.0336575 -0.442755 0.896009</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.5">
            <TRANSLATION>91.2128 4.88321e-005 7.06339e-005</TRANSLATION>
            <ROTATION>0.000807158 0.0337861 -0.415875 0.908793</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.53333">
            <TRANSLATION>91.2128 4.75387e-005 5.76888e-005</TRANSLATION>
            <ROTATION>-0.000295912 0.0340065 -0.389249 0.920504</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.56667">
            <TRANSLATION>91.2128 4.03115e-005 5.26926e-005</TRANSLATION>
            <ROTATION>-0.00135409 0.0343098 -0.36304 0.931141</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.6">
            <TRANSLATION>91.2128 4.24457e-005 4.26678e-005</TRANSLATION>
            <ROTATION>-0.00233977 0.0346774 -0.337933 0.940528</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.63333">
            <TRANSLATION>91.2128 4.66312e-005 5.37676e-005</TRANSLATION>
            <ROTATION>-0.0032403 0.0350896 -0.314315 0.948664</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.66667">
            <TRANSLATION>91.2129 3.77102e-005 4.34942e-005</TRANSLATION>
            <ROTATION>-0.00402876 0.0355151 -0.293017 0.955439</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.7">
            <TRANSLATION>91.2128 4.18511e-005 5.85303e-005</TRANSLATION>
            <ROTATION>-0.00469832 0.0359271 -0.27442 0.960927</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.73333">
            <TRANSLATION>91.2129 4.11344e-005 2.44448e-005</TRANSLATION>
            <ROTATION>-0.00523753 0.0362951 -0.259056 0.965166</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.76667">
            <TRANSLATION>91.2128 3.60566e-005 4.89386e-005</TRANSLATION>
            <ROTATION>-0.00563409 0.0365878 -0.24751 0.968178</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.8">
            <TRANSLATION>91.2128 3.87415e-005 4.48362e-005</TRANSLATION>
            <ROTATION>-0.00588286 0.0367817 -0.24015 0.970021</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.83333">
            <TRANSLATION>91.2129 3.73856e-005 3.61495e-005</TRANSLATION>
            <ROTATION>-0.00596943 0.0368511 -0.237567 0.970654</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.86667">
            <TRANSLATION>91.2128 4.06705e-005 2.5501e-005</TRANSLATION>
            <ROTATION>-0.00586253 0.0368 -0.240454 0.969945</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.9">
            <TRANSLATION>91.2128 4.06705e-005 2.5501e-005</TRANSLATION>
            <ROTATION>-0.00555145 0.036657 -0.24881 0.967842</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.93333">
            <TRANSLATION>91.2128 4.06705e-005 2.5501e-005</TRANSLATION>
            <ROTATION>-0.00506137 0.0364481 -0.261848 0.964407</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.96667">
            <TRANSLATION>91.2128 4.06705e-005 2.5501e-005</TRANSLATION>
            <ROTATION>-0.00441131 0.0362021 -0.278906 0.959626</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="4">
            <TRANSLATION>91.2128 4.06705e-005 2.5501e-005</TRANSLATION>
            <ROTATION>-0.00362262 0.0359497 -0.29928 0.953481</ROTATION>
        </KEYFRAME>
    </TRACK>
    <TRACK NUMKEYFRAMES="32" BONEID="60">
        <KEYFRAME TIME="0">
            <TRANSLATION>72.7357 -1.61703e-006 1.28109e-005</TRANSLATION>
            <ROTATION>0.00467341 -0.0282649 -0.0312175 0.999102</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3">
            <TRANSLATION>72.7357 1.07692e-005 3.9353e-006</TRANSLATION>
            <ROTATION>0.00467339 -0.028265 -0.0312175 0.999102</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.03333">
            <TRANSLATION>72.7357 1.61303e-005 1.66317e-005</TRANSLATION>
            <ROTATION>0.00467342 -0.0282649 -0.0312175 0.999102</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.06667">
            <TRANSLATION>72.7357 -6.21167e-006 -3.46275e-006</TRANSLATION>
            <ROTATION>0.00467342 -0.0282649 -0.0312175 0.999102</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.1">
            <TRANSLATION>72.7357 1.7472e-007 2.02526e-005</TRANSLATION>
            <ROTATION>0.0046734 -0.0282649 -0.0312175 0.999102</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.13333">
            <TRANSLATION>72.7357 9.85208e-006 4.60304e-005</TRANSLATION>
            <ROTATION>0.00467341 -0.0282649 -0.0312175 0.999102</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.16667">
            <TRANSLATION>72.7357 1.60431e-005 -8.25728e-007</TRANSLATION>
            <ROTATION>0.00467337 -0.0282649 -0.0312175 0.999102</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.2">
            <TRANSLATION>72.7357 -1.18258e-005 -1.15562e-005</TRANSLATION>
            <ROTATION>0.00467339 -0.0282649 -0.0312175 0.999102</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.23333">
            <TRANSLATION>72.7357 2.94209e-007 1.06317e-005</TRANSLATION>
            <ROTATION>0.00467339 -0.0282649 -0.0312175 0.999102</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.26667">
            <TRANSLATION>72.7357 -8.77417e-006 2.06404e-005</TRANSLATION>
            <ROTATION>0.00467345 -0.0282649 -0.0312175 0.999102</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.3">
            <TRANSLATION>72.7357 6.7073e-006 5.26405e-005</TRANSLATION>
            <ROTATION>0.00467343 -0.028265 -0.0312175 0.999102</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.33333">
            <TRANSLATION>72.7357 6.88124e-006 2.26269e-005</TRANSLATION>
            <ROTATION>0.0046734 -0.0282649 -0.0312175 0.999102</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.36667">
            <TRANSLATION>72.7357 -3.57982e-005 3.16057e-005</TRANSLATION>
            <ROTATION>0.00467337 -0.0282649 -0.0312175 0.999102</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.4">
            <TRANSLATION>72.7357 -9.59668e-006 2.49264e-005</TRANSLATION>
            <ROTATION>0.00467338 -0.0282649 -0.0312175 0.999102</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.43333">
            <TRANSLATION>72.7357 -1.50613e-005 -1.64708e-005</TRANSLATION>
            <ROTATION>0.00467342 -0.0282649 -0.0312175 0.999102</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.46667">
            <TRANSLATION>72.7357 -2.89419e-005 -1.81675e-005</TRANSLATION>
            <ROTATION>0.00467343 -0.028265 -0.0312175 0.999102</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.5">
            <TRANSLATION>72.7357 -1.51273e-005 4.92059e-007</TRANSLATION>
            <ROTATION>0.00467343 -0.0282649 -0.0312174 0.999102</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.53333">
            <TRANSLATION>72.7357 -1.24491e-005 2.30548e-005</TRANSLATION>
            <ROTATION>0.00467343 -0.0282649 -0.0312175 0.999102</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.56667">
            <TRANSLATION>72.7357 2.32299e-005 4.81231e-005</TRANSLATION>
            <ROTATION>0.00467342 -0.0282649 -0.0312175 0.999102</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.6">
            <TRANSLATION>72.7357 2.05929e-005 6.7274e-005</TRANSLATION>
            <ROTATION>0.00467344 -0.0282649 -0.0312175 0.999102</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.63333">
            <TRANSLATION>72.7357 1.63031e-005 2.6265e-005</TRANSLATION>
            <ROTATION>0.00467345 -0.0282649 -0.0312175 0.999102</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.66667">
            <TRANSLATION>72.7357 1.04166e-005 2.48224e-005</TRANSLATION>
            <ROTATION>0.0046734 -0.0282649 -0.0312175 0.999102</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.7">
            <TRANSLATION>72.7357 2.136e-005 4.03411e-005</TRANSLATION>
            <ROTATION>0.0046734 -0.0282649 -0.0312175 0.999102</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.73333">
            <TRANSLATION>72.7357 1.59724e-005 6.50903e-005</TRANSLATION>
            <ROTATION>0.00467339 -0.028265 -0.0312175 0.999102</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.76667">
            <TRANSLATION>72.7357 8.35969e-006 2.68285e-005</TRANSLATION>
            <ROTATION>0.00467339 -0.028265 -0.0312175 0.999102</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.8">
            <TRANSLATION>72.7357 6.29816e-007 2.22037e-005</TRANSLATION>
            <ROTATION>0.0046734 -0.0282649 -0.0312175 0.999102</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.83333">
            <TRANSLATION>72.7357 4.87364e-006 4.01586e-005</TRANSLATION>
            <ROTATION>0.00467339 -0.028265 -0.0312174 0.999102</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.86667">
            <TRANSLATION>72.7357 9.66629e-006 4.99856e-005</TRANSLATION>
            <ROTATION>0.00467341 -0.0282648 -0.0312175 0.999102</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.9">
            <TRANSLATION>72.7357 4.53278e-006 3.51966e-005</TRANSLATION>
            <ROTATION>0.00467341 -0.028265 -0.0312175 0.999102</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.93333">
            <TRANSLATION>72.7357 1.23556e-005 3.35502e-005</TRANSLATION>
            <ROTATION>0.00467338 -0.028265 -0.0312175 0.999102</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="3.96667">
            <TRANSLATION>72.7357 -1.708e-006 2.2571e-005</TRANSLATION>
            <ROTATION>0.0046734 -0.0282649 -0.0312175 0.999102</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="4">
            <TRANSLATION>72.7357 1.84476e-005 4.1089e-005</TRANSLATION>
            <ROTATION>0.00467341 -0.0282649 -0.0312175 0.999102</ROTATION>
        </KEYFRAME>
    </TRACK>
</ANIMATION>"""

animation2 = '''\
<HEADER MAGIC="XAF" VERSION="919" />
<ANIMATION NUMTRACKS="1" DURATION="40">
    <TRACK BONEID="0" TRANSLATIONREQUIRED="0" TRANSLATIONISDYNAMIC="0" HIGHRANGEREQUIRED="1" NUMKEYFRAMES="2">
        <KEYFRAME TIME="0">
            <ROTATION>0.5 0.5 0.5 -0.5</ROTATION>
        </KEYFRAME>
        <KEYFRAME TIME="40">
            <ROTATION>0.5 0.5 0.5 -0.5</ROTATION>
        </KEYFRAME>
    </TRACK>
</ANIMATION>
'''

material1 = """<HEADER VERSION="910" MAGIC="XRF" />
<MATERIAL NUMMAPS="2">
    <AMBIENT>255 255 255 255 </AMBIENT>
    <DIFFUSE>255 255 255 255</DIFFUSE>
    <SPECULAR>255 255 255 255</SPECULAR>
    <SHININESS>0</SHININESS>
    <MAP TYPE="Diffuse Color">Female01_Anime01_hair_Marla_Brunette.tga</MAP>
    <MAP TYPE="Opacity">Female01_Anime01_hair_Marla_Brunette_whatever.tga</MAP>
  
</MATERIAL>"""

animmorph1 = """<HEADER VERSION="910" MAGIC="XPF" />
<ANIMATION NUMTRACKS="1" DURATION="0.166667">
    <TRACK NUMKEYFRAMES="6" MORPHNAME="eyes.Blink.Clamped">
        <KEYFRAME TIME="0">
            <WEIGHT>0</WEIGHT>
        </KEYFRAME>
        <KEYFRAME TIME="0.0333333">
            <WEIGHT>0.5</WEIGHT>
        </KEYFRAME>
        <KEYFRAME TIME="0.0666667">
            <WEIGHT>1</WEIGHT>
        </KEYFRAME>
        <KEYFRAME TIME="0.1">
            <WEIGHT>0.740741</WEIGHT>
        </KEYFRAME>
        <KEYFRAME TIME="0.133333">
            <WEIGHT>0.259259</WEIGHT>
        </KEYFRAME>
        <KEYFRAME TIME="0.166667">
            <WEIGHT>0</WEIGHT>
        </KEYFRAME>
    </TRACK>
</ANIMATION>"""
        
if __name__ == "__main__":
    testing.ut.main()
